Debian-facile

Bienvenue sur Debian-Facile, site d'aide pour les nouveaux utilisateurs de Debian.

Vous n'êtes pas identifié(e).

#1 03-01-2018 10:45:10

Debian Alain
Adhérent(e)
Lieu : BREST
Distrib. : W$10 / stable / ubuntu / testing
Noyau : Linux 4.18.0-2-amd64 debian
(G)UI : Gnome wayland / Gdm3
Inscription : 11-03-2017
Site Web

[résolu] au sujet de la compilation

bonjour et bonne  année à tous .

voilà :
j'ai trouvé ce fil :  https://debian-facile.org/doc:systeme:kernel:compiler

pour compiler , il est parfait . sauf pour compiler le 4.15 car il manque un fichier là  :

apt install build-essential fakeroot dpkg-dev libssl-dev bc gnupg dirmngr libncurses5-dev



ayant , grâce à ce fil , réussi à compiler moulte kernels , j'ai eu envie de faire pareil avec les patchs .

mon but est d' assembler  un kernel et  son patch  puis de le compiler avant de l'installer  et  de démarrer dessus .

j'ai trouvé ceci :

https://debian-facile.org/utilisateurs: … el-linux?s
https://wiki.debian-fr.xyz/Compiler_et_ … _son_noyau
https://www.kernel.org/doc/html/v4.11/p … tches.html

qui semblent tous dire que pour patcher un noyau , il faut passer par /usr/src/ où il faut télécharger et compiler le kernel là aussi .

pourtant , ce fil :

https://www.debian-facile.org/viewtopic.php?id=15611

précise , et je le crois volontiers , les risques qu'il y a à compiler (et de manière plus générale , à travailler) en root .
ce lien précise aussi , apparemment , que cette méthode est risquée et serai devenue caduque ....

oui mais comment on fait , alors , pour patcher un noyau ? si on le fait encore ....

scorpio810 m'avait donné , dans ce fil :  https://debian-facile.org/viewtopic.php?id=19131&p=3

la marche à suivre pour modifier le k10temp du kernel :

wget https://cdn.kernel.org/pub/linux/kernel … 1.3.tar.xz
tar Jxvf linux-4.11.3.tar.xz

# on remplace et écrase l'ancien fichier k10temp.c

ln -s linux-4.11.3 linux
cd linux
cp /boot/config-$(uname -r) .config
make oldconfig
fakeroot make -j$(nproc) deb-pkg LOCALVERSION=-vanilla KDEB_PKGVERSION=1



déjà un patch avant l'heure ...

mais pour les patches de kernel.org , à appliquer au dernier kernel stable ....

je sais pas  comment faire ?
je les ai téléchargés et décompactés mais pour le reste ....

et d'ailleurs , déjà , pour commencer , quid de leur pertinence et de leur utilité ?

Dernière modification par Debian Alain (03-01-2018 19:32:40)


1498812139.jpg   Moonlight Shadow Technobase
RYZEN7 1700X - PRIME X370 PRO - 16 Go DDR4 - RADEON PULSE RX 550 4GB DDR5 OC UEFI - CORSAIR RM750X - SSD crucial MX500 500GB

Hors ligne

#2 03-01-2018 11:14:34

robert2a
Membre
Lieu : France
Inscription : 15-11-2014

Re : [résolu] au sujet de la compilation

Bonjour
je vais dire peu etre une bétise , mais par exemple le patch du noyau 4.15-rc6 sert a mettre a jour le noyau 4.14-rc5 en version 4.14-rc6
enfin moi je le vois comme cela (jamais fait )
sur kernel.org le patch disponible (en 4.14-rc6) est la pour mettre a jour le 4.14-rc5  (pas pour etre appliqué sur le rc6)
je sais pas si je suis bien clair tongue et si pour toi aussi
au lieu d installer le nouveau noyau , on  patche l'ancien pour le mettre a la dernière version.

Hors ligne

#3 03-01-2018 18:34:10

naguam
Membre
Lieu : Quelque part
Distrib. : Plusieurs
Noyau : Ça dépend
(G)UI : La CLI il n'y a que ça de vrai!
Inscription : 13-06-2016

Re : [résolu] au sujet de la compilation

pour compiler , il est parfait . sauf pour compiler le 4.15 car il manque un fichier là  :

apt install build-essential fakeroot dpkg-dev libssl-dev bc gnupg dirmngr libncurses5-dev



J'ai en grande partie rédigé ce tutoriel, pour le 4.15 que manque-t-il comme paquet? (que je le rajoute car "tuto créé a l'époque du 4.10-rc2 environ")


Sinon le fait que tu doives aller dans /usr/src c'est que c'est la que par convention on met les sources de son kernel (par exemple quand tu compile ton kernel sous gentoo tu met tes sources dedans et compiles en root) mais debian a une approche plus sécure qui permet de compiler en user pour éviter la casse.
D'ailleurs sous debian il est déconseillé de faire make install alors que cela se fait soufvent dans d'autres distrib.
C'est pour cela qu'avec le tutoriel on vous fait compiler et empaqueter dans des .deb.
Le kernel en plus n'as pas de make uninstall donc il est très pratique d'installer avec des paquets car on peut ensuite les déinstaller avec apt.

Pour en revenir au patch, si tu veux patcher pas besoin d'avoir les sources dans /usr/src tu les mets ou tu veux, juste quand tu utilise la commande pou patcher, tu spécifies le chemin


(Ps: pour les personnes qui commencent a être a l'aise peuvent ne plus suivre le tuto à la lettre et tâter a droite a gauche. Le tutoriel est juste une valeur sûre qui fonctionne auquelle on peu racrocher)

Dernière modification par naguam (03-01-2018 18:48:53)

Hors ligne

#4 03-01-2018 18:45:12

Debian Alain
Adhérent(e)
Lieu : BREST
Distrib. : W$10 / stable / ubuntu / testing
Noyau : Linux 4.18.0-2-amd64 debian
(G)UI : Gnome wayland / Gdm3
Inscription : 11-03-2017
Site Web

Re : [résolu] au sujet de la compilation

salut naguam .

bonne année .

il manque le paquet

LIBELF-DEV



sans ça , tu auras du mal à compiler le 4.15

mais fais tes tests et dis moi . normalement , tu vas me  confirmer .

~$ apt show libelf-dev -a


Package: libelf-dev
Version: 0.170-0.2
Priority: optional
Section: libdevel
Source: elfutils
Maintainer: Kurt Roeckx <kurt@roeckx.be>
Installed-Size: 372 kB
Depends: libelf1 (= 0.170-0.2), zlib1g-dev
Conflicts: libelfg0-dev
Homepage: https://sourceware.org/elfutils/
Tag: devel::library, role::devel-lib
Download-Size: 71,5 kB
APT-Sources: http://ftp.fr.debian.org/debian unstable/main amd64 Packages
Description: libelf1 development libraries and header files
 libelf1 provides a shared library which allows reading and writing of ELF
 files on a high level.
 .
 This package contains development libraries and header files for libelf1.

Package: libelf-dev
Version: 0.170-0.1
Priority: optional
Section: libdevel
Source: elfutils
Maintainer: Kurt Roeckx <kurt@roeckx.be>
Installed-Size: 372 kB
Depends: libelf1 (= 0.170-0.1)
Conflicts: libelfg0-dev
Homepage: https://sourceware.org/elfutils/
Tag: devel::library, role::devel-lib
Download-Size: 71,4 kB
APT-Manual-Installed: yes
APT-Sources: http://ftp.fr.debian.org/debian testing/main amd64 Packages
Description: libelf1 development libraries and header files
 libelf1 provides a shared library which allows reading and writing of ELF
 files on a high level.
 .
 This package contains development libraries and header files for libelf1.



tu peux aussi demander à robert2a qui te  confirmera lui aussi .
sinon , moi , j'ai pas  trouvé la solution , c'est lui .
beaucoup plus débrouillard que moi .

Dernière modification par Debian Alain (03-01-2018 19:30:30)


1498812139.jpg   Moonlight Shadow Technobase
RYZEN7 1700X - PRIME X370 PRO - 16 Go DDR4 - RADEON PULSE RX 550 4GB DDR5 OC UEFI - CORSAIR RM750X - SSD crucial MX500 500GB

Hors ligne

#5 03-01-2018 18:49:24

naguam
Membre
Lieu : Quelque part
Distrib. : Plusieurs
Noyau : Ça dépend
(G)UI : La CLI il n'y a que ça de vrai!
Inscription : 13-06-2016

Re : [résolu] au sujet de la compilation

Merci smile et j'ai modifié mon post précédant pour t'expliquer un peu.

Ok sinon je testerais, il n'y avais pas besoin de ce paquets avant.
Je ferais des tests mais plus tard car en ce moment j'ai pas le temps.

Dernière modification par naguam (03-01-2018 18:51:36)

Hors ligne

#6 03-01-2018 19:09:38

raleur
Membre
Inscription : 03-10-2014

Re : [résolu] au sujet de la compilation

Debian Alain a écrit :

ayant , grâce à ce fil , réussi à compiler moulte kernels , j'ai eu envie de faire pareil avec les patchs .


Quels patchs ?

robert2a a écrit :

je vais dire peu etre une bétise , mais par exemple le patch du noyau 4.15-rc6 sert a mettre a jour le noyau 4.14-rc5 en version 4.14-rc6


Tu ne t'emmêlerais pas les pinceaux entre les versions 4.14 et 4.15 ?
Ça dépend de quel patch tu parles. Il y a le patch normal qui s'applique à la précédente version principale (ex : 4.14 vers 4.15rc6), et le patch incrémental qui s'applique à la précédente révision (ex : 4.15rc5 vers 4.15rc6).

robert2a a écrit :

sur kernel.org le patch disponible (en 4.14-rc6) est la pour mettre a jour le 4.14-rc5  (pas pour etre appliqué sur le rc6)


Note qu'on peut aussi appliquer un patch "à rebours" (revert) pour revenir de la version finale à la version initiale. Par exemple appliquer le patch incremental rc5-rc6 à rebours sur la version rc6 pour revenir à la version rc5.

robert2a a écrit :

au lieu d installer le nouveau noyau , on  patche l'ancien pour le mettre a la dernière version.


Dans ce cas il peut être nécessaire d'appliquer deux patchs. Par exemple pour passer du noyau 4.14.11 au 4.15rc6 :
1) appliquer le patch 4.14.11 à rebours pour revenir en 4.14
2) appliquer le patch 4.15rc6

En ligne

#7 03-01-2018 19:19:54

Debian Alain
Adhérent(e)
Lieu : BREST
Distrib. : W$10 / stable / ubuntu / testing
Noyau : Linux 4.18.0-2-amd64 debian
(G)UI : Gnome wayland / Gdm3
Inscription : 11-03-2017
Site Web

Re : [résolu] au sujet de la compilation

ouaip .

donc je me suis mélangé les pinceaux .

je croyais que les patchs du kernel 4.14.11 sur kernel.org servait à rendre ce dernier encore plus compatible .

je me suis donc trompé .

il ne servent que à downgrader ou upgrader une version de kernel .

pour la compilation , seul le kernel suffit .

pas besoin de patch .

autrement dit , je me faisais des noeuds au cerveau pour rien .

merci râleur .

1498812139.jpg   Moonlight Shadow Technobase
RYZEN7 1700X - PRIME X370 PRO - 16 Go DDR4 - RADEON PULSE RX 550 4GB DDR5 OC UEFI - CORSAIR RM750X - SSD crucial MX500 500GB

Hors ligne

#8 03-01-2018 19:51:14

robert2a
Membre
Lieu : France
Inscription : 15-11-2014

Re : [résolu] au sujet de la compilation

merci raleur pour l' explication , oui je me suis trompé entre 4.14 et 4.15 pour le rc5 et 6
je n'ai jamais appliqué de patch donc c'est une inconnu pour moi

Hors ligne

Pied de page des forums